// Simon     MAZAS
// Sbastien PEN									IUP2
// David     MONTET
//
//			**************************************
//			****	AUTOMATE  DETERMINISTE    ****
//			**************************************

#include <string.h>
#include <stdio.h>

#define NBCARMAX       10
#define MESSAGE_PAIR   "Le mot saisi contient un nombre pair de 0"
#define MESSAGE_IMPAIR "Le mot saisi contient un nombre impair de 0"

void main ()
{
	int  tab[2][2];         //Tableau d'implmentation de l'automate
	int  etat = 0;			//Etat courant
	int  transition;		//Transition  appliquer  l'tat
	
	char chaine_lu[NBCARMAX];     //Chaine de caractres saisie
	int  lg = 0;			//Longueur de la chane lue
	int  i;                 //Indice de tableau

	printf("-= Simulation Automate deterministe 1  =-\n\n\n\n");
	
	//Lecture du mot compos de 0 et de 1
	printf("Saisissez un mot de 0 et de 1 :");	
	scanf("%s", chaine_lu);
	lg = strlen ( chaine_lu );
	while (lg > NBCARMAX)
	{
		printf("\nErreur de saisie : le mot doit etre compos de moins de %d caracteres\nRessaisir le mot : ",NBCARMAX);
		scanf("%s", chaine_lu);
		lg = strlen ( chaine_lu );
	}
	
	// Codage de l'automate	
	tab[0][0] = 1;  //impair
	tab[1][0] = 0;  //pair
	tab[0][1] = 0;
	tab[1][1] = 1;
		
	// parcours du tableau --> simulation de l'automate
	for ( i = 0; i < lg; i++)
	{	
		if (chaine_lu[i] == '0') 
			transition = 0;
		if (chaine_lu[i] == '1') 
			transition = 1;

		//on passe a l'etat suivant
		etat = tab[etat][transition];

		//Trace  l'ecran
		if ( etat == 1 ) printf("  nombre de 0 impair \n");
		if ( etat == 0 ) printf("  nombre de 0 pair \n");
	}
	
	//Affichage du rsultat :pair ou impair
	if ( etat == 0) 
		printf("\n\n%s\n",MESSAGE_PAIR);
	else
		printf("\n\n%s\n",MESSAGE_IMPAIR);
}
