// Simon     MAZAS
// Sbastien PENN									IUP2
// David     MONTET
//
//			**************************************
//		    ***	  AUTOMATE  NON DETERMINISTE  ****
//			**************************************

#include <string.h>
#include <stdio.h>
#include <conio.h>


//Variables globales
#define LG_TAB 50

char tab_etat   [LG_TAB][3];	//Tableau des etats
char traitement0[LG_TAB];
char traitement1[LG_TAB];
int indice1;
int indice2;

//***********************************************************
void etat_suivant1 ( char etat )
{
  int i;

  for ( i=0;i<=LG_TAB;i++)
  {
	  if (tab_etat[i][0] == etat && tab_etat[i][1] == '0')
	  {
		  traitement1[indice2] = tab_etat[i][2];
		  indice2 ++;
	  }
  }
}

//************************************************************
void etat_suivant2 ( char etat )
{
  int i;

  for ( i=0;i<=LG_TAB;i++)
  {
	  if (tab_etat[i][0] == etat && tab_etat[i][1] == '1')
	  {
		  traitement1[indice2] = tab_etat[i][2];
		  indice2 ++;
	  }
  }
}



void main ( )
{
	char chaine [50];
	char etat_final;
	char etat_courant;

    int i, j, lg;

	printf("-= Simulation Automate non deterministe  =-\n");
	printf("      reconnaissance du mot 111000\n\n\n\n");
	printf("Saisissez un mot de 0 et de 1 :");	

	indice1 = 0;
	indice2 = 0;

	//Definition de l'automate
	tab_etat[0][0] = 'a';
	tab_etat[0][1] = '0';
	tab_etat[0][2] = 'a';

	tab_etat[1][0] = 'a';
	tab_etat[1][1] = '1';
	tab_etat[1][2] = 'a';

	tab_etat[2][0] = 'a';
	tab_etat[2][1] = '1';
	tab_etat[2][2] = 'b';

	tab_etat[3][0] = 'b';
	tab_etat[3][1] = '1';
	tab_etat[3][2] = 'c';

	tab_etat[4][0] = 'c';
	tab_etat[4][1] = '1';
	tab_etat[4][2] = 'd';

	tab_etat[5][0] = 'd';
	tab_etat[5][1] = '0';
	tab_etat[5][2] = 'e';

	tab_etat[6][0] = 'e';
	tab_etat[6][1] = '0';
	tab_etat[6][2] = 'f';

	tab_etat[7][0] = 'f';
	tab_etat[7][1] = '0';
	tab_etat[7][2] = 'g';

	tab_etat[8][0] = 'g';
	tab_etat[8][1] = '0';
	tab_etat[8][2] = 'g';

	tab_etat[9][0] = 'g';
	tab_etat[9][1] = '1';
	tab_etat[9][2] = 'g';

	etat_courant = 'a';
	etat_final = 'g';
	traitement0[0] = etat_courant;
	indice1 = 1;

	fflush(stdin);
	//Lecture de la chaine d'entree
	scanf("%s",chaine);
	lg = strlen(chaine);

   // parcours du tableau --> simulation de l'automate
	printf("Liste des etats accedes\n");
	for(i=0;i<lg;i++)
	{	
		if (chaine[i]=='0') 
		{
			for(j=0;j<indice1;j++)
				etat_suivant1(traitement0[j]);
		}

		if (chaine[i]=='1') 
		{
			for(j=0;j<indice1;j++)
				etat_suivant2 ( traitement0[j] );
		}

		for (j=0;j<indice2;j++)
		{
			traitement0[j]=traitement1[j];
	
		}
		printf(" %c,", traitement1[indice2-1]);
		indice1 = indice2;
		indice2 = 0;
	}
	indice2 = 0;


	for (i=0;(i<indice1)&&(indice2==0);i++)
	{
		if (traitement0[i] == etat_final)
			indice2 = 1;
	}
	if (indice2 == 1)
		printf ("\n\n   Chaine reconnue\n\n\n");
	else
		printf("\n\n    Chaine non reconnue\n\n");
}

