// Simon     MAZAS
// Sbastien PENN									IUP2
// David     MONTET
//
//			**************************************
//		    ***	           GRAPHE		   	  ****
//			**************************************
//Ecrire le programme qui parcours le graphe a partir d'un etat donn
//et affiche la liste des sommets pouvant etre atteint

#include <string.h>
#include <stdio.h>
#include <conio.h>

#define NB_ARC 8
#define NB_SOMMET 7

int arc   [NB_ARC][2];	//Tableau des arcs
int bcktrack[NB_SOMMET];//Tableau des sommets atteints


//***********************************************************
void main ( )
{ 
	// Dclaration des variables
	int cpt_cours, cpt_suivants, i, j, depart;
	int sommet_cours[NB_SOMMET];
	int sommet_suivants[NB_SOMMET];
	
	printf("-= Simulation d'un graphe  =-\n");
	printf("     \n\n");
	printf("Saisissez un sommet:");	

	//Definition de l'automate
	arc[0][0] = 0;
	arc[0][1] = 1;

	arc[2][0] = 0;
	arc[2][1] = 6;

	arc[1][0] = 1;
	arc[1][1] = 0;

	arc[3][0] = 5;
	arc[3][1] = 6;

	arc[4][0] = 5;
	arc[4][1] = 4;

	arc[5][0] = 2;
	arc[5][1] = 3;

	arc[6][0] = 6;
	arc[6][1] = 5;

	arc[7][0] = 5;
	arc[7][1] = 2;

	fflush(stdin);
	// Lecture de la chaine d'entree
	cpt_cours = 1; // nombre de sommets accessibles
	scanf("%d",&sommet_cours[0]);

	// Initialisation du tableau de back tracking
	bcktrack[sommet_cours[0]] = -1;

	// Remplissage du back track tant que des sommets peuvent tre atteints
	while (cpt_cours > 0)
	{
		// remplissage du backtrack  partir des sommets en cours
		for (i=0; i<cpt_cours; i++)
		{
			for (j=0;j<NB_ARC;j++)
			{
				if ( arc[j][0] == sommet_cours[i] && bcktrack[arc[j][1]] == NULL)
				{
	  				bcktrack[arc[j][1]] = arc[j][0];
				}
			}
		}
		// mmorisation des sommets pouvant tre atteints
		cpt_suivants = 0;
		for (i=0; i<cpt_cours; i++)
		{
			for (j=0; j<NB_SOMMET; j++)
			{
				if (bcktrack[j] == sommet_cours[i])
				{
					sommet_suivants[cpt_suivants] = j;
					cpt_suivants++;
				}
			}
		}
		// initialisation des sommets en cours
		cpt_cours = cpt_suivants;
		for (i=0; i<cpt_cours; i++)
		{
			sommet_cours[i]=sommet_suivants[i];
		}
	}
	
	// affichage du backtrack
	for (i=0; i<NB_SOMMET; i++)
	{
		printf("| %d |",bcktrack[i]);
	}

	// affichage des sommets parcourus
	printf ("\nSommets parcourus \n");
	for (i=0; i<NB_SOMMET; i++)
	{
		if (bcktrack[i] != 0)
			printf("| %d |",i);
	}

	// affichage d'un chemin
	printf ("\nChemin le plus court \n");
	depart = -1;
    j=NB_SOMMET;
	while (j>0)
	{
		for(j=NB_SOMMET;j>0;j--)
		{
			if (bcktrack[j] == depart)
			{
				depart = j;
				printf("%d",depart);
			}
		}
	}
	printf ("\n\nAu revoir ...");	
}

